/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8630_SUPSTPO.sql

Descrio:
Carrega os preos para um fornecedor informado.                          
Carrega tambm os dados necessrios para o clculo do preo econmico.    

Criao:
12/05/2004 Joo Fernando dos Reis Corra
*/

CREATE OR REPLACE PROCEDURE PRECOS_TO_FORN
                        (P_CDFILIAL     IN ITEMCOLE.CDFILIAL%TYPE,
                         P_CDFILIPROC   IN ITEMCOLE.CDFILIAL%TYPE,
                         P_NRCOLEPRECO  IN ITEMCOLE.NRCOLEPRECO%TYPE,
                         P_CDREGIAO     IN ITEMCOLE.CDREGIAO%TYPE,
                         P_CDFORNECED   IN ITEMCOLE.CDFORNECED%TYPE,
                         P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
                         P_CDMARCA      IN MARCA.CDMARCA%TYPE,
                         P_IDATUREG     IN VARCHAR2,
                         P_IDATUFORN    IN VARCHAR2)
IS
   V_CDEMPRESA  EMPRESA.CDEMPRESA%TYPE;
   V_CDINSCMUNI INSCRMUNICIP.CDINSCMUNI%TYPE;
   V_CDINSCESTA INSCRESTAD.CDINSCESTA%TYPE;

   V_DTCOLEPREC COLETAPR.DTCOLEPREC%TYPE;
   V_COUNTAUX   NUMBER;
   V_NRSEQPRELIST ITEMCOLE.NRSEQPRELIST%TYPE;
   V_IDPRECALT    ITEMCOLE.IDPRECALT%TYPE;
BEGIN
   SELECT
      MAX(NRSEQPRELIST),
      MAX(IDPRECALT)
   INTO
      V_NRSEQPRELIST,
      V_IDPRECALT
   FROM
      ITEMCOLE
   WHERE ITEMCOLE.CDFILIAL    = P_CDFILIAL
     AND ITEMCOLE.NRCOLEPRECO = P_NRCOLEPRECO;

   FOR C_FORN_REGIAO IN
      (SELECT DISTINCT
          CDREGIAO, CDFORNECED
       FROM
          ITEMCOLE
       WHERE
          ITEMCOLE.CDFILIAL    = P_CDFILIAL    AND
          ITEMCOLE.NRCOLEPRECO = P_NRCOLEPRECO AND
          ITEMCOLE.CDREGIAO    = DECODE(P_IDATUREG, 'T', ITEMCOLE.CDREGIAO, P_CDREGIAO) AND
          ITEMCOLE.CDFORNECED  <> P_CDFORNECED AND
          EXISTS (SELECT 1
                  FROM PRODFORNCOMP P
                  WHERE P.CDFORNECED  = ITEMCOLE.CDFORNECED
                    AND P.CDPRODCOMPL = P_CDPRODUTO) AND
          NOT EXISTS(SELECT
                        CDFORNECED,
                        CDREGIAO
                     FROM
                        REFOREG
                     WHERE
                        REFOREG.CDFORNECED = ITEMCOLE.CDFORNECED AND
                        REFOREG.CDREGIAO   = ITEMCOLE.CDREGIAO))
   LOOP
      SELECT
         COUNT(*) INTO V_COUNTAUX
      FROM
         ITEMCOLE
      WHERE
         CDFILIAL    = P_CDFILIAL    AND
         NRCOLEPRECO = P_NRCOLEPRECO AND
         CDPRODUTO   = P_CDPRODUTO   AND
         CDMARCA     = P_CDMARCA     AND
         CDFORNECED  = C_FORN_REGIAO.CDFORNECED AND
         CDREGIAO    = C_FORN_REGIAO.CDREGIAO;
      /* SE NA REGIAO/FORNECEDOR DE DESTINO NAO HOUVER O PRODUTO DUPLICADO ENTAO ELE SERA INSERIDO */
      IF V_COUNTAUX = 0 THEN
         FOR C_INSERT IN
            (SELECT ITEMCOLE.CDFILIAL, NRCOLEPRECO, CDPRODUTO, CDMARCA,
                    DTINIVALITM, DTFINVALITM, VRPRECUNIITM, VRPERDESITM,
                    CDTIPCOB, CDSEGMARCCOL, IDTIPFREITM, NRPZOENTCOL,
                    IDITMLISPREC, CDFORMPGTO, IDTPFOPGTCOL, NRPARCPGTCOL,
                    NRDIAPGFXCOL, IDUTDIAPGCOL, QTACMPITMCOL, DSPZOPGTCONC,
                    VRINDICEITMCOL
             FROM ITEMCOLE,
                  FILIAL
             WHERE
                ITEMCOLE.CDFILIAL    = P_CDFILIAL    AND
                NRCOLEPRECO = P_NRCOLEPRECO AND
                CDFORNECED  = P_CDFORNECED  AND
                CDPRODUTO   = P_CDPRODUTO   AND
                CDMARCA     = P_CDMARCA     AND
                ITEMCOLE.CDREGIAO    = P_CDREGIAO    AND

                FILIAL.CDFILIAL = P_CDFILIPROC AND
                NVL(FILIAL.IDFUNCAOFILI, 'O') = 'O' 

             UNION ALL

             SELECT ITEMCOLE.CDFILIAL, ITEMCOLE.NRCOLEPRECO, ITEMCOLE.CDPRODUTO, CDMARCA,
                    DTINIVALITM, DTFINVALITM, VRPRECUNIITM, VRPERDESITM,
                    CDTIPCOB, CDSEGMARCCOL, IDTIPFREITM, NRPZOENTCOL,
                    IDITMLISPREC, CDFORMPGTO, IDTPFOPGTCOL, NRPARCPGTCOL,
                    NRDIAPGFXCOL, IDUTDIAPGCOL, QTACMPITMCOL, DSPZOPGTCONC,
                    VRINDICEITMCOL
             FROM ITEMCOLE,
                 (SELECT
                     PARAMPRODSUP.CDREGIAO,
                     PARAMPRODSUP.CDPRODUTO
                  FROM
                     PARAMPRODSUP,
                     FILIAL
                  WHERE
                     FILIAL.CDFILIAL = P_CDFILIPROC AND
                     FILIAL.IDFUNCAOFILI = 'C' AND
                     FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL AND
                     PARAMPRODSUP.IDFILINEGCOR = 'S'

                  UNION ALL

                  SELECT
                     PARAMPRODSUP.CDREGIAO,
                     PARAMPRODSUP.CDPRODUTO
                  FROM
                     PARAMPRODSUP,
                     FILIAL
                  WHERE
                     FILIAL.CDFILIAL = P_CDFILIPROC  AND
                     FILIAL.IDFUNCAOFILI = 'R' AND
                     FILIAL.CDFILIAL = PARAMPRODSUP.CDFILICTRL AND
                     PARAMPRODSUP.IDFILINEGREG = 'S') PARAMPRODSUP

             WHERE
                ITEMCOLE.CDFILIAL    = P_CDFILIAL    AND
                ITEMCOLE.NRCOLEPRECO = P_NRCOLEPRECO AND
                ITEMCOLE.CDFORNECED  = P_CDFORNECED  AND
                ITEMCOLE.CDPRODUTO   = P_CDPRODUTO   AND
                CDMARCA              = P_CDMARCA     AND
                ITEMCOLE.CDREGIAO    = P_CDREGIAO    AND

                PARAMPRODSUP.CDPRODUTO = ITEMCOLE.CDPRODUTO AND
                PARAMPRODSUP.CDREGIAO = C_FORN_REGIAO.CDREGIAO)
         LOOP
            INSERT INTO ITEMCOLE(CDFILIAL, NRCOLEPRECO, CDPRODUTO, CDMARCA, CDFORNECED,
                                 CDREGIAO, DTINIVALITM, DTFINVALITM,
                                 VRPRECUNIITM, VRPERDESITM, IDITMCOTPREC,
                                 CDTIPCOB, CDSEGMARCCOL, IDTIPFREITM, NRPZOENTCOL,
                                 IDITMLISPREC, CDFORMPGTO, IDTPFOPGTCOL, NRPARCPGTCOL,
                                 NRDIAPGFXCOL, IDUTDIAPGCOL, QTACMPITMCOL,
                                 DSPZOPGTCONC, IDATUREGIINC, IDATUFORNINC, NRSEQPRELIST,
                                 IDPRECALT, VRINDICEITMCOL)
            VALUES(C_INSERT.CDFILIAL,     C_INSERT.NRCOLEPRECO,  C_INSERT.CDPRODUTO,
                   C_INSERT.CDMARCA,      C_FORN_REGIAO.CDFORNECED, C_FORN_REGIAO.CDREGIAO,
                   C_INSERT.DTINIVALITM,  C_INSERT.DTFINVALITM,  C_INSERT.VRPRECUNIITM,
                   C_INSERT.VRPERDESITM, 'S', C_INSERT.CDTIPCOB, C_INSERT.CDSEGMARCCOL,
                   C_INSERT.IDTIPFREITM,  C_INSERT.NRPZOENTCOL,  C_INSERT.IDITMLISPREC,
                   C_INSERT.CDFORMPGTO,   C_INSERT.IDTPFOPGTCOL, C_INSERT.NRPARCPGTCOL,
                   C_INSERT.NRDIAPGFXCOL, C_INSERT.IDUTDIAPGCOL, C_INSERT.QTACMPITMCOL,
                   C_INSERT.DSPZOPGTCONC, P_IDATUREG, P_IDATUFORN, V_NRSEQPRELIST,
                   V_IDPRECALT, C_INSERT.VRINDICEITMCOL);
         END LOOP;
         INSERT INTO PZOPGTITMCOL
         (CDFILIAL, NRCOLEPRECO,  CDFORNECED,   CDPRODUTO,
          CDMARCA,  NRDIASPGTCOL, VRPERCPGTCOL, CDREGIAO)
         SELECT
          PZOPGTITMCOL.CDFILIAL, PZOPGTITMCOL.NRCOLEPRECO, C_FORN_REGIAO.CDFORNECED,
          PZOPGTITMCOL.CDPRODUTO,PZOPGTITMCOL.CDMARCA, PZOPGTITMCOL.NRDIASPGTCOL,
          PZOPGTITMCOL.VRPERCPGTCOL, C_FORN_REGIAO.CDREGIAO
         FROM
          PZOPGTITMCOL
         WHERE
          PZOPGTITMCOL.CDREGIAO    = P_CDREGIAO    AND
          PZOPGTITMCOL.CDFORNECED  = P_CDFORNECED  AND

          PZOPGTITMCOL.CDFILIAL    = P_CDFILIAL    AND
          PZOPGTITMCOL.NRCOLEPRECO = P_NRCOLEPRECO AND
          PZOPGTITMCOL.CDPRODUTO   = P_CDPRODUTO   AND
          PZOPGTITMCOL.CDMARCA     = P_CDMARCA;
      END IF;

      SELECT  MAX(DTCOLEPREC) INTO V_DTCOLEPREC
      FROM COLETAPR
      WHERE
         CDFILIAL    = P_CDFILIAL AND
         NRCOLEPRECO = P_NRCOLEPRECO;

      COMMIT;

      FOR C_PRECOS IN
           (SELECT
              ITEMCOLE.CDPRODUTO,
              PRODUTO.CDARVPROD,
              ITEMCOLE.CDMARCA,
              ITEMCOLE.VRPRECUNIITM,
              ITEMCOLE.CDFORMPGTO,
              ITEMCOLE.IDTPFOPGTCOL,
              ITEMCOLE.NRPARCPGTCOL,
              ITEMCOLE.NRDIAPGFXCOL,
              ITEMCOLE.IDUTDIAPGCOL,
              ITEMCOLE.VRINDICEITMCOL
            FROM
              ITEMCOLE, PRODUTO
            WHERE
              ITEMCOLE.CDPRODUTO   = PRODUTO.CDPRODUTO AND
              ITEMCOLE.CDFILIAL    = P_CDFILIAL        AND
              ITEMCOLE.NRCOLEPRECO = P_NRCOLEPRECO     AND
              ITEMCOLE.CDREGIAO    = P_CDREGIAO        AND
              ITEMCOLE.CDFORNECED  = P_CDFORNECED      AND
              ITEMCOLE.CDPRODUTO   = P_CDPRODUTO       AND
              ITEMCOLE.CDMARCA     = P_CDMARCA         AND
              NOT EXISTS
               (SELECT
                  REFOREG.CDREGIAO
                FROM
                  REFOREG
                WHERE
                  REFOREG.CDREGIAO    = ITEMCOLE.CDREGIAO AND
                  REFOREG.CDFORNECED  = ITEMCOLE.CDFORNECED)) LOOP

/* CUSOR QUE RETORNARA TODOS ITENS QUE SERAO DUPLICADOS */

         UPDATE ITEMCOLE
         SET VRPRECUNIITM = C_PRECOS.VRPRECUNIITM,
             IDITMCOTPREC = 'S',
             IDATUREGIALT = P_IDATUREG,
             IDATUFORNALT = P_IDATUFORN,
             VRINDICEITMCOL = C_PRECOS.VRINDICEITMCOL
         WHERE
           CDFILIAL    = P_CDFILIAL     AND
           NRCOLEPRECO = P_NRCOLEPRECO  AND
           CDREGIAO    = C_FORN_REGIAO.CDREGIAO AND
           CDFORNECED  = C_FORN_REGIAO.CDFORNECED AND
           CDPRODUTO   = C_PRECOS.CDPRODUTO  AND
           CDMARCA     = C_PRECOS.CDMARCA;

/*###############################  IMPOSTO ######################################*/

           SELECT
              SUBSTR(EMITENTE(P_CDFILIAL, C_PRECOS.CDPRODUTO, C_FORN_REGIAO.CDFORNECED), 3, 2) AS CDEMPRESA
           INTO
              V_CDEMPRESA
           FROM
              PARAMGERAL;

           SELECT
              MAX(EMPRESA.CDEMPRESA),
              MIN(INSCRMUNICIP.CDINSCMUNI) AS CDINSCMUNI,
              MIN(INSCRESTAD.CDINSCESTA)   AS CDINSCESTA
           INTO
              V_CDEMPRESA, V_CDINSCMUNI, V_CDINSCESTA
           FROM
              EMPRESA,
              INSCRMUNICIP,
              INSCRESTAD
           WHERE
              EMPRESA.CDEMPRESA = V_CDEMPRESA           AND
              EMPRESA.CDEMPRESA = INSCRMUNICIP.CDEMPRESA AND
              EMPRESA.CDEMPRESA = INSCRESTAD.CDEMPRESA;

         IMPOSTO_ITEMCOL(V_CDEMPRESA,      V_CDINSCESTA,             C_FORN_REGIAO.CDFORNECED, P_CDFILIAL,
                           P_NRCOLEPRECO,    C_FORN_REGIAO.CDFORNECED, C_FORN_REGIAO.CDREGIAO,   C_PRECOS.CDPRODUTO,
                           C_PRECOS.CDMARCA, V_DTCOLEPREC);
         UPDATE ITEMCOLE
         SET VRPRECUNIITM = VRPRECUNIITM
         WHERE
           CDFILIAL    = P_CDFILIAL     AND
           NRCOLEPRECO = P_NRCOLEPRECO  AND
           CDREGIAO    = C_FORN_REGIAO.CDREGIAO AND
           CDFORNECED  = C_FORN_REGIAO.CDFORNECED AND
           CDPRODUTO   = C_PRECOS.CDPRODUTO  AND
           CDMARCA     = C_PRECOS.CDMARCA;
         COMMIT;
      END LOOP;
   END LOOP;
END;
/